
funcproto local,EnumProcessos,QWORD
funcproto LOCAL,EnumModules,QWORD,DWORD
funcproto LOCAL,EnumThread,QWORD,DWORD
.data
	
.code

;***************************************************
; Func es el offset a la funcin callback del estilo
;
;  Funcion Callback LpPE:QWORD  (puntero a estructura PROCESSENTRY32)
;
;  Si devuelve 1 se continua con la enumeracin
;              0 se para la enumeracin
;***************************************************

function EnumProcessos,func:QWORD
	begin_alloc
		alloc_var hSnapshot:QWORD
		alloc_var pe32:PROCESSENTRY32 
	end_alloc

	
	 invoke CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS , 0     
		 
	 mov hSnapshot,rax
	
     mov pe32.PROCESSENTRY32.dwSize, sizeof PROCESSENTRY32 
     
     invoke Process32First, hSnapshot, addr pe32

EnumProcessos_otro:
     @IF <<cmp rax,0>>, NOEQUAL?
     	
     	; reservamos la memoria en la pila 
     	sub rsp,8*4
     	
     	;arg 1
     	lea rcx,pe32
     	; llamada a la funcin
     	mov rax,func
     	call rax
     	
     	; liberamos la memoria
     	add rsp,8*4
     	
     	; comprobamos la devolucin 
    	cmp rax,0
    	je 	EnumProcessos_FIN 			
        
     	
		invoke Process32Next, hSnapshot, addr pe32     	
     	jmp EnumProcessos_otro
    
     @ENDIF

EnumProcessos_FIN:     
     invoke CloseHandle, hSnapshot

exitf

;***************************************************
; Func es el offset a la funcin callback del estilo
;
;  Funcion Callback LpME:QWORD  (puntero a estructura MODULEENTRY32)
;
;  Si devuelve 1 se continua con la enumeracin
;              0 se para la enumeracin
;***************************************************
function EnumModules,func:QWORD,ProcID:DWORD

	begin_alloc
		alloc_var hSnapshot:QWORD
		alloc_var me32:MODULEENTRY32
	end_alloc

	
	 invoke CreateToolhelp32Snapshot,TH32CS_SNAPMODULE , ProcID     
	 @IF <<cmp rax,INVALID_HANDLE_VALUE>>, NOEQUAL?	 
	
	 	mov hSnapshot,rax
	
     	mov me32.MODULEENTRY32.dwSize, sizeof MODULEENTRY32 
     
     	invoke Module32First, hSnapshot, addr me32

EnumModules_otro:
     	@IF <<cmp rax,0>>, NOEQUAL?
     	
     		; reservamos la memoria en la pila 
     		sub rsp,8*4
     	
     		;arg 1
     		lea rcx,me32
	     	; llamada a la funcin
    	 	mov rax,func
     		call rax
     	
     		; liberamos la memoria
     		add rsp,8*4
     	
     		; comprobamos la devolucin 
    		cmp rax,0
    		je 	EnumModules_FIN 			
        
     	
			invoke Module32Next, hSnapshot, addr me32     	
     		jmp EnumModules_otro
     	@ENDIF

EnumModules_FIN:     
     	invoke CloseHandle, hSnapshot
	@ENDIF
exitf


;***************************************************
; Func es el offset a la funcin callback del estilo
;
;  Funcion Callback LpTE:QWORD  (puntero a estructura THREADENTRY32)
;
;  Si devuelve 1 se continua con la enumeracin
;              0 se para la enumeracin
;***************************************************
function EnumThread,func:QWORD,ProcID:DWORD

	begin_alloc
		alloc_var hSnapshot:QWORD
		alloc_var te32:THREADENTRY32
	end_alloc

	
	 invoke CreateToolhelp32Snapshot,TH32CS_SNAPTHREAD, ProcID    
	 @IF <<cmp rax,INVALID_HANDLE_VALUE>>, NOEQUAL?	 
	
	 	mov hSnapshot,rax
		
		
	
     	mov te32.THREADENTRY32.dwSize, sizeof THREADENTRY32 
     
     	invoke Thread32First, hSnapshot, addr te32

EnumThread_otro:
     	@IF <<cmp rax,0>>, NOEQUAL?
     	
     		xor rax,rax
     		mov eax, te32.THREADENTRY32.th32OwnerProcessID
     		@IF <<cmp eax,ProcID>>,EQUAL?
     		
		
				; reservamos la memoria en la pila 
    	 		sub rsp,8*4
     	
     			;arg 1
     			lea rcx,te32
		     	; llamada a la funcin
    		 	mov rax,func
     			call rax
     	
     			; liberamos la memoria
     			add rsp,8*4
     	
     			; comprobamos la devolucin 
    			cmp rax,0
    			je 	EnumThread_FIN 			
 			       
     		@ENDIF
     		mov te32.THREADENTRY32.dwSize, sizeof THREADENTRY32 
			invoke Thread32Next, hSnapshot, addr te32     	
     		jmp EnumThread_otro
     	@ENDIF

EnumThread_FIN:     
     	invoke CloseHandle, hSnapshot
	@ENDIF
exitf

